---
project.description: Release notes for all Alpakka Kafka 1.1.x releases.
---
# Alpakka Kafka 1.1.x

@@@ note
In case you are browsing a specific version's documentation: check out the [latest release notes](https://github.com/akka/alpakka-kafka/releases)
@@@

Alpakka Kafka 1.1 changes the internals of how offset commits are sent to the Kafka broker. The new implementation is very beneficial for high-throughput consumers as committing is now connected to the regular polling of the Kafka consumer, which reduces pressure on Kafka.

It adds a new source for advanced usage: `committablePartitionedManualOffsetSource` which may be used when offsets are stored external to Kafka, but tools for consumer lag which rely on offsets being committed to Kafka are in use.

As a new experimental feature, offset committing is now possible without applying backpressure to the stream when commits are not processed at the same speed. This can be controlled via the `delivery` committer setting.

Exceptions from the Kafka consumer API are now properly passed back and fail the stream.

This goes along with a few improvements to the documentation.

# 1.1.0

Released: 2019-10-10

No changes affecting the functionality since 1.1.0-RC2.

The detailed list of changes is found in [the 1.1.0 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v1.1.0).


# 1.1.0-RC2

Released: 2019-10-02

- Committable partitioned source with manual offset seek support [#908](https://github.com/akka/alpakka-kafka/issues/908) by [@seglo](https://github.com/seglo)

The detailed list of changes is found in [the 1.1.0-RC2 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v1.1.0-RC2).

This release is compiled and tested against [Akka 2.5](https://doc.akka.io/docs/akka/2.5/) for Scala 2.11, 2.12 and 2.13, [Akka 2.6-M8](https://doc.akka.io/docs/akka/2.6/) for Scala 2.12, and 2.13 and both Akka versions on Adopt OpenJDK 1.8 and 11.

**If we do not get any reports that speak against it, we'll release Alpakka Kafka 1.1.0 in a few weeks.**

This release contains contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&s=40"> **ennru**](https://github.com/ennru) | 10 | 303 | 207 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&s=40"> **seglo**](https://github.com/seglo) | 1 | 249 | 25 |
| [<img width="20" alt="raboof" src="https://avatars2.githubusercontent.com/u/131856?v=4&s=40"> **raboof**](https://github.com/raboof) | 1 | 1 | 1 |

# 1.1.0-RC1

Released: 2019-09-05

Alpakka Kafka 1.1 changes the internals of how offset commits are sent to the Kafka broker. The new implementation is very beneficial for high-throughput consumers as committing is now connected to the regular polling of the Kafka consumer, which reduces pressure on Kafka.

As a new experimental feature, offset committing is now possible without applying backpressure to the stream when commits are not processed at the same speed. This can be controlled via the `delivery` committer setting.

Exceptions from the Kafka consumer API are now properly passed back and fail the stream.

This goes along with a few improvements to the documentation.


## Notable changes since 1.0.5

- Aggregate offsets and commit before poll [#862](https://github.com/akka/alpakka-kafka/issues/862)
- Special-casing single offset committing [#868](https://github.com/akka/alpakka-kafka/issues/868)
- Introduce setting for committing without backpressure [#883](https://github.com/akka/alpakka-kafka/pull/883)
- Capture exceptions from Kafka consumer and pass to involved stages [#887](https://github.com/akka/alpakka-kafka/pull/887)

The detailed list of changes is found in [the 1.1.0-RC1 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v1.1.0-RC1).

This release is compiled and tested against [Akka 2.5](https://doc.akka.io/docs/akka/2.5/) for Scala 2.11, 2.12 and 2.13, [Akka 2.6-M6](https://doc.akka.io/docs/akka/2.6/) for Scala 2.12, and 2.13 and both Akka versions on Adopt OpenJDK 1.8 and 11.

This release contains contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&s=40"> **ennru**](https://github.com/ennru) | 25 | 947 | 369 |
| [<img width="20" alt="2m" src="https://avatars3.githubusercontent.com/u/422086?v=4&s=40"> **2m**](https://github.com/2m) | 9 | 93 | 66 |
| [<img width="20" alt="TimMoore" src="https://avatars0.githubusercontent.com/u/44385?v=4&s=40"> **TimMoore**](https://github.com/TimMoore) | 2 | 10 | 33 |
| [<img width="20" alt="bwmcadams" src="https://avatars3.githubusercontent.com/u/98358?v=4&s=40"> **bwmcadams**](https://github.com/bwmcadams) | 1 | 1 | 1 |
