---
project.description: Release notes for all Alpakka Kafka 2.0.x releases.
---
# Alpakka Kafka 2.0.x

@@@ note
In case you are browsing a specific version's documentation: check out the [latest release notes](https://github.com/akka/alpakka-kafka/releases)
@@@

The Alpakka Kafka 2.0 series features

* upgrade to the Apache Kafka client 2.4.0
* `Producer.committableSink` behaves as a combination of `Producer.flexiFlow` and `Committer.sink`, but has a special-purpose implementation
* built-in @ref:[Akka Discovery](../discovery.md) support
* More versatile use of Testcontainers in Alpakka Kafka Testkit [#939](https://github.com/akka/alpakka-kafka/issues/939).
* Removal of some API which was deprecated since 1.0.0 or earlier.
* Internal filter to avoid emitting records of revoked partitions [#946](https://github.com/akka/alpakka-kafka/issues/946) and [#992](https://github.com/akka/alpakka-kafka/issues/992)

# 2.0.7

Released: 2021-02-03

## Notable changes since 2.0.6

**This release only affects the Alpakka Kafka TestKit**

## Alpakka Kafka Testkit

- Increase default cluster start timeouts and make configurable (backport) [#1311](https://github.com/akka/alpakka-kafka/issues/1311) by [@seglo](https://github.com/seglo)
- Use restart script [#1310](https://github.com/akka/alpakka-kafka/issues/1310) by [@seglo](https://github.com/seglo)

The milestone contains everything [*closed in 2.0.7*](https://github.com/akka/alpakka-kafka/issues?q=is%3Aclosed+milestone%3A2.0.7).

Since 2.0.6 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="seglo" src="https://avatars.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 2 | 89 | 12 |

# 2.0.6

Released: 2020-12-22

## Notable changes since 2.0.5

**The most relevant change in this release is the update of TestContainers to 1.15.1 (see below)**

- Handle any combination of Committables in CommitObservationLogic [#1262](https://github.com/akka/alpakka-kafka/issues/1262) by [@seglo](https://github.com/seglo)
- Fix message-batch loss when rebalancing partitioned sources [#1263](https://github.com/akka/alpakka-kafka/issues/1263) by [@jhooda](https://github.com/jhooda)
- Producer.committableSink: offsets not committed, when MultiMessage is empty [#1200](https://github.com/akka/alpakka-kafka/issues/1200) by [@herzrasen](https://github.com/herzrasen)

## Alpakka Kafka TestKit

- Update default CP version and make docker image/tag configurable [#1287](https://github.com/akka/alpakka-kafka/issues/1287) by [@seglo](https://github.com/seglo)
- Testkit: Make Testcontainer logs visible [#1281](https://github.com/akka/alpakka-kafka/issues/1281) by [@seglo](https://github.com/seglo)
- Testcontainers Kafka 1.15.1 (was 1.14.3) [#1257](https://github.com/akka/alpakka-kafka/issues/1257) by [@scala-steward](https://github.com/scala-steward)
- TestKit: make consumerDefaults parameterless again [#1292](https://github.com/akka/alpakka-kafka/issues/1292)

## Dependencies

- jackson-databind 2.10.5.1 (was 2.10.5) [#1270](https://github.com/akka/alpakka-kafka/issues/1270) by [@scala-steward](https://github.com/scala-steward)
- Add note about provided jackson dependency [#1245](https://github.com/akka/alpakka-kafka/issues/1245) by [@seglo](https://github.com/seglo)

# 2.0.5

Released: 2020-09-09

## Notable changes since 2.0.4

- Allow typed Actor Systems in SendProducer and DiscoverySupport [#1192](https://github.com/akka/alpakka-kafka/issues/1192) by [@ennru](https://github.com/ennru)
- Generate version information when publishing artifacts [#1188](https://github.com/akka/alpakka-kafka/issues/1188) by [@marcospereira](https://github.com/marcospereira)

## Alpakka Kafka core

- Deprecate RestrictedConsumer.committed(TopicPartition) [#1178](https://github.com/akka/alpakka-kafka/issues/1178) by [@seglo](https://github.com/seglo)
- Cleanup build warnings [#1177](https://github.com/akka/alpakka-kafka/issues/1177) by [@seglo](https://github.com/seglo)
- Order logging params for RetriableException consumer failures [#1168](https://github.com/akka/alpakka-kafka/issues/1168) by [@seglo](https://github.com/seglo)
- Generate version information when publishing artifacts [#1188](https://github.com/akka/alpakka-kafka/issues/1188) by [@marcospereira](https://github.com/marcospereira)

## Alpakka Kafka Testkit

- Cleanup build warnings [#1177](https://github.com/akka/alpakka-kafka/issues/1177) by [@seglo](https://github.com/seglo)

## Documentation

- Run & materialize stream in Akka Cluster Sharding Example [#1190](https://github.com/akka/alpakka-kafka/issues/1190) by [@seglo](https://github.com/seglo)
- Cleanup testcontainers docs snippets [#1180](https://github.com/akka/alpakka-kafka/issues/1180) by [@seglo](https://github.com/seglo)

## Tests

- Reduce bloat of log when testsuite log reported in failed travis build [#1182](https://github.com/akka/alpakka-kafka/issues/1182) by [@seglo](https://github.com/seglo)
- Simplify consuming stream for AssignmentSpec "consume from the specified topic pattern" test [#1181](https://github.com/akka/alpakka-kafka/issues/1181) by [@seglo](https://github.com/seglo)
- Cleanup build warnings [#1177](https://github.com/akka/alpakka-kafka/issues/1177) by [@seglo](https://github.com/seglo)

## Updates

- scalapb-runtime 0.10.8 (was 0.10.7) [#1171](https://github.com/akka/alpakka-kafka/issues/1171) by [@scala-steward](https://github.com/scala-steward)
- metrics-core 4.1.12.1 (was 4.1.11) [#1194](https://github.com/akka/alpakka-kafka/issues/1194) by [@scala-steward](https://github.com/scala-steward)
- sbt-java-formatter 0.6.0 (was 0.5.1) [#1193](https://github.com/akka/alpakka-kafka/issues/1193) by [@scala-steward](https://github.com/scala-steward)
- jackson-databind 2.10.5 (was 2.10.4) [#1169](https://github.com/akka/alpakka-kafka/issues/1169) by [@scala-steward](https://github.com/scala-steward)
- mockito-core 3.4.6 (was 2.28.2) [#1173](https://github.com/akka/alpakka-kafka/issues/1173) by [@scala-steward](https://github.com/scala-steward)
- sbt-scalafmt 2.4.2 (was 2.4.0) [#1174](https://github.com/akka/alpakka-kafka/issues/1174) by [@scala-steward](https://github.com/scala-steward)
- Update paradox akka to 0.35, new links to LB.com [#1167](https://github.com/akka/alpakka-kafka/issues/1167) by [@johanandren](https://github.com/johanandren)

The milestone contains everything [*closed in 2.0.5*](https://github.com/akka/alpakka-kafka/issues?q=is%3Aclosed+milestone%3A2.0.5).

Since 2.0.4 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 7 | 104 | 94 |
| [<img width="20" alt="scala-steward" src="https://avatars1.githubusercontent.com/u/43047562?v=4&amp;s=40"/> **scala-steward**](https://github.com/scala-steward) | 7 | 7 | 7 |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 1 | 75 | 23 |
| [<img width="20" alt="marcospereira" src="https://avatars0.githubusercontent.com/u/4576?v=4&amp;s=40"/> **marcospereira**](https://github.com/marcospereira) | 1 | 36 | 0 |
| [<img width="20" alt="johanandren" src="https://avatars3.githubusercontent.com/u/666915?v=4&amp;s=40"/> **johanandren**](https://github.com/johanandren) | 1 | 1 | 1 |

# 2.0.4

Released: 2020-07-22

## Notable changes since 2.0.3

- Emit offset batches on timer [#1160](https://github.com/akka/alpakka-kafka/issues/1160) by [@jyates](https://github.com/jyates)
- Do not commit offsets for unassigned partitions [#1123](https://github.com/akka/alpakka-kafka/issues/1123) by [@jyates](https://github.com/jyates)
- Use bulk update API for shard allocation [#1139](https://github.com/akka/alpakka-kafka/issues/1139) by [@chbatey](https://github.com/chbatey)
- Add produce consume check to KafkaContainerCluster [#1131](https://github.com/akka/alpakka-kafka/issues/1131) by [@seglo](https://github.com/seglo)
- Deprecate embedded kafka support [#1136](https://github.com/akka/alpakka-kafka/issues/1136) by [@seglo](https://github.com/seglo)

## Alpakka Kafka core

- Emit offset batches on timer [#1160](https://github.com/akka/alpakka-kafka/issues/1160) by [@jyates](https://github.com/jyates)
- Do not commit offsets for unassigned partitions [#1123](https://github.com/akka/alpakka-kafka/issues/1123) by [@jyates](https://github.com/jyates)

## Alpakka Kafka Akka Cluster Sharding

- Use bulk update API for shard allocation [#1139](https://github.com/akka/alpakka-kafka/issues/1139) by [@chbatey](https://github.com/chbatey)
- Don't use ctx.log in KafkaClusterSharding [#1138](https://github.com/akka/alpakka-kafka/issues/1138) by [@chbatey](https://github.com/chbatey)

## Alpakka Kafka Testkit

- Deprecate embedded kafka support [#1136](https://github.com/akka/alpakka-kafka/issues/1136) by [@seglo](https://github.com/seglo)
- Replace embedded kafka with schema registry with testcontainers [#1135](https://github.com/akka/alpakka-kafka/issues/1135) by [@seglo](https://github.com/seglo)
- Add produce consume check to KafkaContainerCluster [#1131](https://github.com/akka/alpakka-kafka/issues/1131) by [@seglo](https://github.com/seglo)

## Updates

- mockito-core 2.28.2 (was 2.24.5) [#1151](https://github.com/akka/alpakka-kafka/issues/1151) by [@scala-steward](https://github.com/scala-steward)
- scala-collection-compat 2.1.6 (was 2.1.2) [#1152](https://github.com/akka/alpakka-kafka/issues/1152) by [@scala-steward](https://github.com/scala-steward)
- jul-to-slf4j, log4j-over-slf4j 1.7.30 (was 1.7.26) [#1155](https://github.com/akka/alpakka-kafka/issues/1155) by [@scala-steward](https://github.com/scala-steward)
- embedded-kafka 2.4.1.1 (was 2.4.1) [#1147](https://github.com/akka/alpakka-kafka/issues/1147) by [@scala-steward](https://github.com/scala-steward)
- protobuf-java 3.12.2 (was 3.11.4) [#1142](https://github.com/akka/alpakka-kafka/issues/1142) by [@scala-steward](https://github.com/scala-steward)
- sbt 1.3.13 (was 1.3.9) [#1153](https://github.com/akka/alpakka-kafka/issues/1153) by [@scala-steward](https://github.com/scala-steward)
- akka-stream-alpakka-csv 2.0.1 (was 2.0.0) [#1143](https://github.com/akka/alpakka-kafka/issues/1143) by [@scala-steward](https://github.com/scala-steward)

The milestone contains everything [*closed in 2.0.4*](https://github.com/akka/alpakka-kafka/issues?q=is%3Aclosed+milestone%3A2.0.4).

Since 2.0.3 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 5 | 1412 | 354 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 4 | 417 | 210 |
| [<img width="20" alt="jyates" src="https://avatars2.githubusercontent.com/u/197388?v=4&amp;s=40"/> **jyates**](https://github.com/jyates) | 2 | 157 | 6 |
| [<img width="20" alt="chbatey" src="https://avatars1.githubusercontent.com/u/1866779?v=4&amp;s=40"/> **chbatey**](https://github.com/chbatey) | 2 | 45 | 31 |
| [<img width="20" alt="MiLk" src="https://avatars0.githubusercontent.com/u/29782?v=4&amp;s=40"/> **MiLk**](https://github.com/MiLk) | 2 | 3 | 3 |
| [<img width="20" alt="Zhen-hao" src="https://avatars3.githubusercontent.com/u/10957195?v=4&amp;s=40"/> **Zhen-hao**](https://github.com/Zhen-hao) | 1 | 3 | 7 |
| [<img width="20" alt="raboof" src="https://avatars2.githubusercontent.com/u/131856?v=4&amp;s=40"/> **raboof**](https://github.com/raboof) | 1 | 2 | 0 |

# 2.0.3

Released: 2020-05-14

## Notable changes since 2.0.2

- @ref[Akka Cluster Sharding](../cluster-sharding.md) integration to co-locate Kafka partition reading with Akka Cluster shards by [@seglo](https://github.com/seglo) and [@chbatey](https://github.com/chbatey)
- Retry committing of offsets when failure is marked as retriable [#1111](https://github.com/akka/alpakka-kafka/issues/1111) by [@ennru](https://github.com/ennru)
- Delay commits until the next offset is observed [#1093](https://github.com/akka/alpakka-kafka/issues/1093) by [@seglo](https://github.com/seglo)
- Non-streaming producer wrapper [#1085](https://github.com/akka/alpakka-kafka/issues/1085) by [@ennru](https://github.com/ennru)
- Drain partial offset commit batches on upstream failure [#1058](https://github.com/akka/alpakka-kafka/issues/1058) by [@sdudzin](https://github.com/sdudzin)
- Kafka client 2.4.1 [#1103](https://github.com/akka/alpakka-kafka/issues/1103) by [@ennru](https://github.com/ennru)


## Alpakka Kafka core

- Committing: retry commits marked as retriable [#1111](https://github.com/akka/alpakka-kafka/issues/1111) by [@ennru](https://github.com/ennru)
- Build: Jackson 2.10.4 and sbt plugin updates [#1112](https://github.com/akka/alpakka-kafka/issues/1112) by [@ennru](https://github.com/ennru)
- Security: mask passwords in settings' toString [#1110](https://github.com/akka/alpakka-kafka/issues/1110) by [@ennru](https://github.com/ennru)
- Commit when next offset is observed [#1093](https://github.com/akka/alpakka-kafka/issues/1093) by [@seglo](https://github.com/seglo)
- Non-streaming producer wrapper [#1085](https://github.com/akka/alpakka-kafka/issues/1085) by [@ennru](https://github.com/ennru)
- Simplify commit replying [#1095](https://github.com/akka/alpakka-kafka/issues/1095) by [@ennru](https://github.com/ennru)
- DrainingControl: creation in toMat [#1084](https://github.com/akka/alpakka-kafka/issues/1084) by [@ennru](https://github.com/ennru)
- Simpler use with the new actors API [#1088](https://github.com/akka/alpakka-kafka/issues/1088) by [@ennru](https://github.com/ennru)
- Cluster-sharding: single listener per entity type key + Java DSL [#1080](https://github.com/akka/alpakka-kafka/issues/1080) by [@chbatey](https://github.com/chbatey)
- Drain partial offset commit batches on upstream failure [#1058](https://github.com/akka/alpakka-kafka/issues/1058) by [@sdudzin](https://github.com/sdudzin)
- Kafka cluster sharding support with external sharding allocation [#1067](https://github.com/akka/alpakka-kafka/issues/1067) by [@seglo](https://github.com/seglo)
- Add MetadataClient getCommittedOffsets [#1073](https://github.com/akka/alpakka-kafka/issues/1073) by [@epalace](https://github.com/epalace)


## Alpakka Kafka Testkit

- Testkit: Generify test producer consumer [#1099](https://github.com/akka/alpakka-kafka/issues/1099) by [@claudio-scandura](https://github.com/claudio-scandura)
- Testkit: create ProducerMessage.PassThroughResult [#1096](https://github.com/akka/alpakka-kafka/issues/1096) by [@sebarys](https://github.com/sebarys)
- Set stopTimeout to zero in BaseKafkaTest.consumeString. [#1094](https://github.com/akka/alpakka-kafka/issues/1094) by [@claudio-scandura](https://github.com/claudio-scandura)

The milestone contains everything [*closed in 2.0.3*](https://github.com/akka/alpakka-kafka/issues?q=is%3Aclosed+milestone%3A2.0.3).


Since 2.0.2 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 14 | 1331 | 560 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 6 | 876 | 151 |
| [<img width="20" alt="claudio-scandura" src="https://avatars0.githubusercontent.com/u/1486771?v=4&amp;s=40"/> **claudio-scandura**](https://github.com/claudio-scandura) | 2 | 54 | 17 |
| [<img width="20" alt="sdudzin" src="https://avatars0.githubusercontent.com/u/606713?v=4&amp;s=40"/> **sdudzin**](https://github.com/sdudzin) | 1 | 554 | 46 |
| [<img width="20" alt="chbatey" src="https://avatars1.githubusercontent.com/u/1866779?v=4&amp;s=40"/> **chbatey**](https://github.com/chbatey) | 1 | 224 | 21 |
| [<img width="20" alt="sebarys" src="https://avatars1.githubusercontent.com/u/22937277?v=4&amp;s=40"/> **sebarys**](https://github.com/sebarys) | 1 | 4 | 0 |


# 2.0.2

Released: 2020-02-20

This release fixes 

## Alpakka Kafka core

- CommittingProducerSink: outstanding commits on multi-msg [#1041](https://github.com/akka/alpakka-kafka/issues/1041) by [@gabrielreid](https://github.com/gabrielreid)
- CommittingProducerSink: Fix count on failure [#1043](https://github.com/akka/alpakka-kafka/issues/1043) by [@gabrielreid](https://github.com/gabrielreid)
- Don't close shared Producer on fail [#1046](https://github.com/akka/alpakka-kafka/issues/1046) by [@gabrielreid](https://github.com/gabrielreid)
- Java API `createCommittableOffsetBatch` accepts `Committable` [#1033](https://github.com/akka/alpakka-kafka/issues/1033) by [@jewertow](https://github.com/jewertow)
- Discard of external offsets on rebalance [#1037](https://github.com/akka/alpakka-kafka/issues/1037) by [@gabrielreid](https://github.com/gabrielreid)
- Fix slow-loading offsets during rebalance [#1029](https://github.com/akka/alpakka-kafka/issues/1029) by [@gabrielreid](https://github.com/gabrielreid)

## Alpakka Kafka Testkit

- Upgrade to Confluent Platform 5.4.0 [#1034](https://github.com/akka/alpakka-kafka/issues/1034) by [@seglo](https://github.com/seglo)

The milestone contains everything [*closed in 2.0.2*](https://github.com/akka/alpakka-kafka/milestone/43?closed=1).


Since 2.0.1 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="gabrielreid" src="https://avatars3.githubusercontent.com/u/527401?v=4&amp;s=40"/> **gabrielreid**](https://github.com/gabrielreid) | 5 | 328 | 14 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 5 | 151 | 84 |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 2 | 18 | 21 |
| [<img width="20" alt="jewertow" src="https://avatars2.githubusercontent.com/u/17457695?v=4&amp;s=40"/> **jewertow**](https://github.com/jewertow) | 1 | 44 | 1 |
| [<img width="20" alt="ignasi35" src="https://avatars2.githubusercontent.com/u/762126?v=4&amp;s=40"/> **ignasi35**](https://github.com/ignasi35) | 1 | 16 | 3 |
| [<img width="20" alt="Sebruck" src="https://avatars1.githubusercontent.com/u/2050823?v=4&amp;s=40"/> **Sebruck**](https://github.com/Sebruck) | 1 | 1 | 1 |



# 2.0.1

Released: 2020-01-23

This release fixes 

- CommittableProducer: Record outstanding commits on pass-through [#1022](https://github.com/akka/alpakka-kafka/issues/1022) by [@gabrielreid](https://github.com/gabrielreid)
- Producer: avoid race between failure and upstream finish [#1025](https://github.com/akka/alpakka-kafka/pull/1025)

The detailed list of changes is found in [the 2.0.1 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v2.0.1).

Since 2.0.0 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 2 | 60 | 44 |
| [<img width="20" alt="gabrielreid" src="https://avatars3.githubusercontent.com/u/527401?v=4&amp;s=40"/> **gabrielreid**](https://github.com/gabrielreid) | 1 | 78 | 0 |


# 2.0.0

Released: 2020-01-15

This release doesn't contain any relevant changes over 2.0.0-RC1.

The detailed list of changes is found in [the 2.0.0 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v2.0.0).

Since 1.1.0 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 36 | 4358 | 1566 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 11 | 2692 | 1122 |
| [<img width="20" alt="charlibot" src="https://avatars3.githubusercontent.com/u/5785993?v=4&amp;s=40"/> **charlibot**](https://github.com/charlibot) | 1 | 1901 | 664 |
| [<img width="20" alt="jewertow" src="https://avatars2.githubusercontent.com/u/17457695?v=4&amp;s=40"/> **jewertow**](https://github.com/jewertow) | 1 | 668 | 12 |
| [<img width="20" alt="def1ne" src="https://avatars0.githubusercontent.com/u/3229478?v=4&amp;s=40"/> **def1ne**](https://github.com/def1ne) | 1 | 6 | 0 |
| [<img width="20" alt="shobull" src="https://avatars1.githubusercontent.com/u/3430629?v=4&amp;s=40"/> **shobull**](https://github.com/shobull) | 1 | 1 | 1 |


# 2.0.0-RC1

Released: 2019-12-17

## Notable changes since 2.0.0-M2

* Kafka 2.4.0 Final
    - Update to Kafka 2.4.0 final release [#971](https://github.com/akka/alpakka-kafka/issues/915) by [@ennru](https://github.com/ennru)

* Bugs
    - Rebalance: filter messages of revoked partitions in partitioned sources [#992](https://github.com/akka/alpakka-kafka/issues/992) by [@seglo](https://github.com/seglo)

* Alpakka Kafka API
    - Stage ID traceability [#995](https://github.com/akka/alpakka-kafka/issues/995) by [@seglo](https://github.com/seglo)

This release contains contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 5 | 75 | 85 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 2 | 494 | 186 |

# 2.0.0-M2

Released: 2019-12-03

## Notable changes since 1.1.0

* Kafka 2.4.0-RC1
    - Kafka 2.4.0-RC1 [#971](https://github.com/akka/alpakka-kafka/issues/971) by [@seglo](https://github.com/seglo)

* `Producer.committableSink` behaves as a combination of `Producer.flexiFlow` and `Committer.sink`, but has a special-purpose implementation
    - Committing producer sink: producer and committer in a sink stage [#963](https://github.com/akka/alpakka-kafka/issues/963) by [@ennru](https://github.com/ennru)
    - Create `committableSink` as combination of Producer.flexiFlow an… [#932](https://github.com/akka/alpakka-kafka/issues/932) by [@ennru](https://github.com/ennru)
    - Committer: change type bound to allow offset batches [#931](https://github.com/akka/alpakka-kafka/issues/931) by [@ennru](https://github.com/ennru)

- Akka Discovery support [#836](https://github.com/akka/alpakka-kafka/issues/836) by [@ennru](https://github.com/ennru)

- Add wrapper for Metadata requests #497 [#900](https://github.com/akka/alpakka-kafka/issues/900) by [@jewertow](https://github.com/jewertow)

* Offset batches allow aggregation from multiple consumers [#953](https://github.com/akka/alpakka-kafka/issues/953) by [@ennru](https://github.com/ennru)

* Performance
    - As part of Apache Kafka: `KafkaConsumer` should not throw away already fetched data for paused partitions [apache/kafka#6988](https://github.com/apache/kafka/pull/6988) by [@seglo](https://github.com/seglo)
    - Producer: change default parallelism [#944](https://github.com/akka/alpakka-kafka/issues/944) by [@ennru](https://github.com/ennru)
    - Rebalance: filter messages of revoked partitions [#946](https://github.com/akka/alpakka-kafka/issues/946) by [@ennru](https://github.com/ennru)

* Testkit
    - Use testcontainers for multi-broker integration tests and benchmarks [#939](https://github.com/akka/alpakka-kafka/issues/939) by [@seglo](https://github.com/seglo)
    - Make EmbeddedKafka a provided dependency [#954](https://github.com/akka/alpakka-kafka/issues/954) by [@ennru](https://github.com/ennru)

* Alpakka Kafka API
    - Committable: deprecate commitJavadsl and commitScaladsl [#959](https://github.com/akka/alpakka-kafka/issues/959) by [@ennru](https://github.com/ennru)
    - ConsumerSetting: Add group instance id setter [#861](https://github.com/akka/alpakka-kafka/issues/861) by [@def1ne](https://github.com/def1ne)

* Bugs
    - Commit refreshing: fix bug from aggregating offsets [#975](https://github.com/akka/alpakka-kafka/issues/975) by [@ennru](https://github.com/ennru)
    - Consumer drops records after rebalance [#978](https://github.com/akka/alpakka-kafka/issues/978) band-aided with [#997](https://github.com/akka/alpakka-kafka/pull/997)

The detailed list of changes is found in [the 2.0.0-M2 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v2.0.0-M2).

This release is compiled and tested against Akka [2.5.23](https://doc.akka.io/docs/akka/2.5/), [2.6.0](https://doc.akka.io/docs/akka/2.6/) and Scala 2.11, 2.12, 2.13 on Adopt OpenJDK 8 and 11.

This release contains contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 26 | 4167 | 1434 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 6 | 1521 | 882 |
| [<img width="20" alt="charlibot" src="https://avatars3.githubusercontent.com/u/5785993?v=4&amp;s=40"/> **charlibot**](https://github.com/charlibot) | 1 | 1901 | 664 |
| [<img width="20" alt="jewertow" src="https://avatars2.githubusercontent.com/u/17457695?v=4&amp;s=40"/> **jewertow**](https://github.com/jewertow) | 1 | 668 | 12 |
| [<img width="20" alt="def1ne" src="https://avatars0.githubusercontent.com/u/3229478?v=4&amp;s=40"/> **def1ne**](https://github.com/def1ne) | 1 | 6 | 0 |
| [<img width="20" alt="shobull" src="https://avatars1.githubusercontent.com/u/3430629?v=4&amp;s=40"/> **shobull**](https://github.com/shobull) | 1 | 1 | 1 |

# 2.0.0-M1

The release process failed.
