---
project.description: Release notes for all Alpakka Kafka 2.1.x releases.
---
# Alpakka Kafka 2.1.x

@@@ note
In case you are browsing a specific version's documentation: check out the [latest release notes](https://github.com/akka/alpakka-kafka/releases)
@@@

The Alpakka Kafka 2.1 series features

* Kafka 2.7.0 client
* Akka 2.6.x (dropped Akka 2.5)
* Scala 2.12 and 2.13 (dropped Scala 2.11)
* Testkit: use ScalaTest 3.1.x
* Testkit: default to use Confluent Platform 6.1.1
* Testkit: no longer support Embedded Kafka (Kafka 2.6.0 can't be safely embedded in Scala applications)

# 2.1.1

Released: 2021-07-23

## Alpakka Kafka core

- Upgrade Akka 2.6.15  [#1395](https://github.com/akka/alpakka-kafka/issues/1395) by [@ygree](https://github.com/ygree)
- Fix Lightbend Telemetry context propagation in CommitCollectorStage [#1395](https://github.com/akka/alpakka-kafka/issues/1395) by [@ygree](https://github.com/ygree)

The detailed list of changes is found in [the 2.1.1 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v2.1.1).

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ygree" src="https://avatars.githubusercontent.com/u/4147346?v=4&amp;s=40"/> **ygree**](https://github.com/ygree) | 6 | 68 | 23 |


# 2.1.0

Released: 2021-05-14

## Noteworthy

- Akka typed first documentation user experience [#1370](https://github.com/akka/alpakka-kafka/issues/1370) by [@seglo](https://github.com/seglo)

The detailed list of changes is found in [the 2.1.0 Github release listing](https://github.com/akka/alpakka-kafka/releases/tag/v2.1.0).

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="scala-steward" src="https://avatars.githubusercontent.com/u/43047562?v=4&amp;s=40"/> **scala-steward**](https://github.com/scala-steward) | 5 | 11 | 11 |
| [<img width="20" alt="seglo" src="https://avatars.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 1 | 265 | 7 |

# 2.1.0-RC1

@@@ note
The Apache Kafka clients have a provided dependency on Jackson `2.10.5`, but Akka depends on `2.11.4`.
Alpakka Kafka references `2.11.4`.
@@@

Released: 2021-04-19

## Noteworthy

- Upgrade Akka 2.6.14 and Kafka 2.7.0 [#1355](https://github.com/akka/alpakka-kafka/issues/1355) by [@seglo](https://github.com/seglo)
- Add configurable protection against server-bug induced resets [#1299](https://github.com/akka/alpakka-kafka/issues/1299) by [@jyates](https://github.com/jyates)
- Don't depend on scalatest in testcontainer singleton [#1330](https://github.com/akka/alpakka-kafka/issues/1330) by [@seglo](https://github.com/seglo)

## Alpakka Kafka core

- Upgrade Akka 2.6.14 and Kafka 2.7.0 [#1355](https://github.com/akka/alpakka-kafka/issues/1355) by [@seglo](https://github.com/seglo)
- Add configurable protection against server-bug induced resets [#1299](https://github.com/akka/alpakka-kafka/issues/1299) by [@jyates](https://github.com/jyates)

## Tests

- Upgrade Akka 2.6.14 and Kafka 2.7.0 [#1355](https://github.com/akka/alpakka-kafka/issues/1355) by [@seglo](https://github.com/seglo)
- Increase consumer group summary timeout in build [#1329](https://github.com/akka/alpakka-kafka/issues/1329) by [@seglo](https://github.com/seglo)
- Add configurable protection against server-bug induced resets [#1299](https://github.com/akka/alpakka-kafka/issues/1299) by [@jyates](https://github.com/jyates)
- Migrate build to GitHub actions [#1307](https://github.com/akka/alpakka-kafka/issues/1307) by [@seglo](https://github.com/seglo)

## Alpakka Kafka Testkit

- Upgrade Akka 2.6.14 and Kafka 2.7.0 [#1355](https://github.com/akka/alpakka-kafka/issues/1355) by [@seglo](https://github.com/seglo)
- Don't depend on scalatest in testcontainer singleton [#1330](https://github.com/akka/alpakka-kafka/issues/1330) by [@seglo](https://github.com/seglo)
- Add ProducerResultFactory.multiResult helper for MultiMessage [#1319](https://github.com/akka/alpakka-kafka/issues/1319) by [@ashendon](https://github.com/ashendon)

## Documentation

- Upgrade Akka 2.6.14 and Kafka 2.7.0 [#1355](https://github.com/akka/alpakka-kafka/issues/1355) by [@seglo](https://github.com/seglo)
- Migrate to sonatype snapshot/release repositories [#1353](https://github.com/akka/alpakka-kafka/issues/1353) by [@seglo](https://github.com/seglo)
- Add configurable protection against server-bug induced resets [#1299](https://github.com/akka/alpakka-kafka/issues/1299) by [@jyates](https://github.com/jyates)
- Release notes v2.0.7 (master) [#1317](https://github.com/akka/alpakka-kafka/issues/1317) by [@seglo](https://github.com/seglo)
- Migrate build to GitHub actions [#1307](https://github.com/akka/alpakka-kafka/issues/1307) by [@seglo](https://github.com/seglo)

## Contributors 

Since 2.0.7 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="scala-steward" src="https://avatars.githubusercontent.com/u/43047562?v=4&amp;s=40"/> **scala-steward**](https://github.com/scala-steward) | 39 | 41 | 41 |
| [<img width="20" alt="ennru" src="https://avatars.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 35 | 515 | 296 |
| [<img width="20" alt="seglo" src="https://avatars.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 25 | 2516 | 2593 |
| [<img width="20" alt="octonato" src="https://avatars.githubusercontent.com/u/502982?v=4&amp;s=40"/> **octonato**](https://github.com/octonato) | 2 | 4 | 4 |
| [<img width="20" alt="jyates" src="https://avatars.githubusercontent.com/u/197388?v=4&amp;s=40"/> **jyates**](https://github.com/jyates) | 1 | 925 | 71 |
| [<img width="20" alt="jhooda" src="https://avatars.githubusercontent.com/u/2099200?v=4&amp;s=40"/> **jhooda**](https://github.com/jhooda) | 1 | 381 | 20 |
| [<img width="20" alt="Matzz" src="https://avatars.githubusercontent.com/u/1036919?v=4&amp;s=40"/> **Matzz**](https://github.com/Matzz) | 1 | 94 | 65 |
| [<img width="20" alt="altomch" src="https://avatars.githubusercontent.com/u/8770929?v=4&amp;s=40"/> **altomch**](https://github.com/altomch) | 1 | 51 | 52 |
| [<img width="20" alt="ashendon" src="https://avatars.githubusercontent.com/u/13709042?v=4&amp;s=40"/> **ashendon**](https://github.com/ashendon) | 1 | 8 | 0 |
| [<img width="20" alt="johanandren" src="https://avatars.githubusercontent.com/u/666915?v=4&amp;s=40"/> **johanandren**](https://github.com/johanandren) | 1 | 1 | 1 |
| [<img width="20" alt="kciesielski" src="https://avatars.githubusercontent.com/u/1413553?v=4&amp;s=40"/> **kciesielski**](https://github.com/kciesielski) | 1 | 1 | 1 |

# 2.1.0-M1

Released: 2020-10-22

## Noteworthy

* Kafka 2.6.0 client [#1098](https://github.com/akka/alpakka-kafka/issues/1098)
* Akka 2.6.10 (dropped Akka 2.5) [#1113](https://github.com/akka/alpakka-kafka/issues/1113)
* Scala 2.12 and 2.13 (dropped Scala 2.11) [#1102](https://github.com/akka/alpakka-kafka/issues/1102)
* The testkit does no longer support Embedded Kafka [#1114](https://github.com/akka/alpakka-kafka/issues/1114)
* Scala 2.12.11 and 2.13.2 [#1212](https://github.com/akka/alpakka-kafka/issues/1212) by [@ennru](https://github.com/ennru)

## Alpakka Kafka core

- DiscoverySupport: remove deprecation [#1231](https://github.com/akka/alpakka-kafka/issues/1231) by [@ennru](https://github.com/ennru)
- Drop Akka 2.5 dependency [#1209](https://github.com/akka/alpakka-kafka/issues/1209) by [@seglo](https://github.com/seglo)
- Kafka 2.6.0 client upgrade and drop Scala 2.11 support [#1102](https://github.com/akka/alpakka-kafka/issues/1102) by [@seglo](https://github.com/seglo)
- Commit collector: avoid pushing twice [#1205](https://github.com/akka/alpakka-kafka/issues/1205) by [@ennru](https://github.com/ennru)
- Commit the offset when multi message is empty [#1201](https://github.com/akka/alpakka-kafka/issues/1201) by [@herzrasen](https://github.com/herzrasen)

## Alpakka Kafka Testkit

- testkit: Admin instead of AdminClient [#1183](https://github.com/akka/alpakka-kafka/issues/1183) by [@ennru](https://github.com/ennru)
- Testkit: enable Mima [#1230](https://github.com/akka/alpakka-kafka/issues/1230) by [@ennru](https://github.com/ennru)
- Start & stop Kafka process within running container [#1235](https://github.com/akka/alpakka-kafka/issues/1235) by [@seglo](https://github.com/seglo)
- Drop embedded-kafka testkit support [#1229](https://github.com/akka/alpakka-kafka/issues/1229) by [@seglo](https://github.com/seglo)
- Rollback Confluent Platform version; add Jackson Databind [#1226](https://github.com/akka/alpakka-kafka/issues/1226) by [@ennru](https://github.com/ennru)
- Default to Confluent Platform version to 6.0.0 [#1224](https://github.com/akka/alpakka-kafka/issues/1224) by [@ennru](https://github.com/ennru)

## Documentation

- Docs: show Lightbend Telemetry OpenTracing support [#1237](https://github.com/akka/alpakka-kafka/issues/1237) by [@ennru](https://github.com/ennru)

## Tests

- ScalaTest 3.1 fixes for it tests [#1210](https://github.com/akka/alpakka-kafka/issues/1210) by [@seglo](https://github.com/seglo)
- ScalaTest 3.1 with rewrites [#1207](https://github.com/akka/alpakka-kafka/issues/1207) by [@ennru](https://github.com/ennru)

## Other updates

- akka-stream-alpakka-csv 2.0.2 (was 2.0.1) [#1215](https://github.com/akka/alpakka-kafka/issues/1215) by [@scala-steward](https://github.com/scala-steward)
- Use the latest JDK 8 and 11 versions in CI [#1213](https://github.com/akka/alpakka-kafka/issues/1213) by [@ennru](https://github.com/ennru)
- protobuf-java 3.12.4 (was 3.12.2) [#1170](https://github.com/akka/alpakka-kafka/issues/1170) by [@scala-steward](https://github.com/scala-steward)
- scala-collection-compat 2.2.0 (was 2.1.6) [#1219](https://github.com/akka/alpakka-kafka/issues/1219) by [@scala-steward](https://github.com/scala-steward)
- junit-jupiter-api 5.7.0 (was 5.5.2) [#1217](https://github.com/akka/alpakka-kafka/issues/1217) by [@scala-steward](https://github.com/scala-steward)
- mockito-core 3.5.13 (was 3.4.6) [#1218](https://github.com/akka/alpakka-kafka/issues/1218) by [@scala-steward](https://github.com/scala-steward)
- sbt-mima-plugin 0.8.0 (was 0.7.0) [#1216](https://github.com/akka/alpakka-kafka/issues/1216) by [@scala-steward](https://github.com/scala-steward)
- Lock scalafmt version [#1236](https://github.com/akka/alpakka-kafka/issues/1236) by [@ennru](https://github.com/ennru)

The milestone contains everything [*closed in 2.1.0-M1*](https://github.com/akka/alpakka-kafka/issues?q=is%3Aclosed+milestone%3A2.1.0-M1).

## Contributors

Since 2.0.5 Alpakka Kafka has received contributions by:

| Author | Commits | Lines added | Lines removed |
| ------ | ------- | ----------- | ------------- |
| [<img width="20" alt="ennru" src="https://avatars3.githubusercontent.com/u/458526?v=4&amp;s=40"/> **ennru**](https://github.com/ennru) | 27 | 338 | 253 |
| [<img width="20" alt="seglo" src="https://avatars2.githubusercontent.com/u/1148412?v=4&amp;s=40"/> **seglo**](https://github.com/seglo) | 11 | 1577 | 2228 |
| [<img width="20" alt="scala-steward" src="https://avatars1.githubusercontent.com/u/43047562?v=4&amp;s=40"/> **scala-steward**](https://github.com/scala-steward) | 6 | 6 | 6 |
| [<img width="20" alt="herzrasen" src="https://avatars3.githubusercontent.com/u/20834977?v=4&amp;s=40"/> **herzrasen**](https://github.com/herzrasen) | 1 | 34 | 0 |
